#!/usr/bin/python
# -*- coding: UTF-8 -*-

##载入模块, 使用shell命令
import subprocess 
import csv
 
#print ("python脚本开始")
import sys
input_fasta=sys.argv[1]
genome=sys.argv[2]
input_type=sys.argv[3]
transcript_name=sys.argv[4]

#print (input_fasta)
#print (genome)
#print (input_type)


 #生成随机数
import timeit

a_str = (str(timeit.default_timer())).replace(".","")

inputfile="tmp_input_"+a_str

outputfile="tmp_output_"+a_str

with open (inputfile,'w') as f:
    f.write (">"+transcript_name+"\n")    
    f.write (input_fasta+"\n")
    f.close()
    
#开始执行blast
#print ("blast")
#subprocess.run(["ls"],shell=True)

if input_type in "prot":
    ##/home/lain/miniconda3/bin/makeblastdb -in your_input_file.fasta -dbtype prot -out your_output_db_name  构建索引
    cmd1="/home/lain/miniconda3/bin/blastp -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".prot -evalue 0.001 -outfmt 0 -num_threads 2  -out "+outputfile
    #print (cmd1)
    subprocess.run([cmd1],shell=True)
    i=1;lastline=""
    with open (outputfile,'r') as f: 
        for line in f.readlines():
            if i==1:
                print("---------------------------------------------------------------------------------------------")
            eachline=line.rstrip()
            #if len(line)<10: i+=1; continue
            #if i<20:i+=1;continue
            if "Score     E" in eachline:i+=1;continue
            if "Effective search space used:" in eachline:i+=1;continue    
            if "Posted date:" in eachline:i+=1;continue    
            #if "Matrix" in eachline:i+=1;continue  
            #if "Gap Penalties" in eachline:i+=1;continue       
            if "Neighboring words threshold" in eachline:i+=1;continue   
            if "Window for multiple hit" in eachline:i+=1;continue           
            if "Number of letters in database" in eachline:i+=1;continue           
            if "Number of sequences in database" in eachline:i+=1;continue 
            #if "Gapped" in eachline:i+=1;continue
            #if "Lambda" in eachline:i+=1;continue 
            #if "Lambda" in lastline:i+=1;continue 
 
            if  len(lastline)<1 and len(eachline)<1:i+=1;continue 

            print (eachline)        
            lastline=eachline
            i+=1    
else:
    cmd2="/home/lain/miniconda3/bin/blastn -query "+inputfile+" -db /www/wwwroot/www.winberige.cc/data/"+genome+"/"+genome+".mRNA -evalue 0.001 -outfmt 0 -num_threads 2 -strand plus -out "+outputfile
    #print (cmd2)
    subprocess.run([cmd2],shell=True)
    i=1;lastline=""
    with open (outputfile,'r') as f:
        for line in f.readlines():
            if i==1:
                print("---------------------------------------------------------------------------------------------")

            eachline=line.rstrip()
            if "Score     E" in eachline:i+=1;continue
            if  len(lastline)<1 and len(eachline)<1:i+=1;continue 

            print (eachline)
            lastline=eachline
            i+=1   


      
            
      
#subprocess.run(["/home/lain/miniconda3/bin/conda -h"],shell=True)
subprocess.run(["rm "+inputfile],shell=True) 
subprocess.run(["rm "+outputfile],shell=True)              
      
      
      
      
      
      
      
      
        
        
        
    #
    #subprocess.run(["ls"],shell=True)
    #print("echo <br>")

    #print("echo <br>")
    #subprocess.run(["/home/lain/miniconda3/bin/conda -h"],shell=True)